Index: sys/compat/svr4/svr4_misc.c
===================================================================
RCS file: /cvs/OpenBSD/src/sys/compat/svr4/svr4_misc.c,v
retrieving revision 1.49
retrieving revision 1.49.6.3
diff -u -r1.49 -r1.49.6.3
--- sys/compat/svr4/svr4_misc.c	1 Oct 2007 12:10:55 -0000	1.49
+++ sys/compat/svr4/svr4_misc.c	18 Feb 2009 12:43:25 -0000	1.49.6.3
@@ -101,7 +101,7 @@
     struct svr4_statvfs *);
 static void bsd_statfs_to_svr4_statvfs64(const struct statfs *,
     struct svr4_statvfs64 *);
-static struct proc *svr4_pfind(pid_t pid);
+static struct proc *svr4_pfind(struct inst_proc *, pid_t pid);
 
 static int svr4_mknod(struct proc *, register_t *, char *,
 			   svr4_mode_t, svr4_dev_t);
@@ -816,17 +816,18 @@
 
 
 static struct proc *
-svr4_pfind(pid)
+svr4_pfind(ip, pid)
+	struct inst_proc *ip;
 	pid_t pid;
 {
 	struct proc *p;
 
 	/* look in the live processes */
-	if ((p = pfind(pid)) != NULL)
+	if ((p = pfind(ip, pid)) != NULL)
 		return p;
 
 	/* look in the zombies */
-	LIST_FOREACH(p, &zombproc, p_list)
+	LIST_FOREACH(p, &ip->zombproc, p_list)
 		if (p->p_pid == pid)
 			return p;
 
@@ -862,7 +863,7 @@
 
 	case 2:			/* getsid(pid) */
 		if (SCARG(uap, pid) != 0 &&
-		    (p = svr4_pfind(SCARG(uap, pid))) == NULL)
+		    (p = svr4_pfind(p->p_inst->inst_proc, SCARG(uap, pid))) == NULL)
 			return ESRCH;
 		/* 
 		 * we return the pid of the session leader for this
@@ -877,7 +878,7 @@
 	case 4:			/* getpgid(pid) */
 
 		if (SCARG(uap, pid) != 0 &&
-		    (p = svr4_pfind(SCARG(uap, pid))) == NULL)
+		    (p = svr4_pfind(p->p_inst->inst_proc, SCARG(uap, pid))) == NULL)
 			return ESRCH;
 
 		*retval = (int) p->p_pgrp->pg_id;
@@ -1091,7 +1092,7 @@
 			 * If we got the child via a ptrace 'attach',
 			 * we need to give it back to the old parent.
 			 */
-			if (p->p_oppid && (t = pfind(p->p_oppid))) {
+			if (p->p_oppid && (t = pfind(p->p_inst->inst_proc, p->p_oppid))) {
 				p->p_oppid = 0;
 				proc_reparent(p, t);
 				psignal(t, SIGCHLD);
Index: sys/conf/files
===================================================================
RCS file: /cvs/OpenBSD/src/sys/conf/files,v
retrieving revision 1.438
retrieving revision 1.438.4.1
diff -u -r1.438 -r1.438.4.1
--- sys/conf/files	21 Jul 2008 19:05:21 -0000	1.438
+++ sys/conf/files	12 Sep 2008 13:58:48 -0000	1.438.4.1
@@ -651,6 +651,7 @@
 file kern/kern_exec.c
 file kern/kern_exit.c
 file kern/kern_fork.c
+file kern/kern_inst.c
 file kern/kern_kthread.c
 file kern/kern_ktrace.c			ktrace
 file kern/kern_lock.c
Index: sys/dev/systrace.c
===================================================================
RCS file: /cvs/OpenBSD/src/sys/dev/systrace.c,v
retrieving revision 1.47
retrieving revision 1.47.6.1
diff -u -r1.47 -r1.47.6.1
--- sys/dev/systrace.c	5 Jan 2008 07:33:37 -0000	1.47
+++ sys/dev/systrace.c	16 Sep 2008 23:10:38 -0000	1.47.6.1
@@ -149,15 +149,15 @@
 
 /* Needs to be called with fst locked */
 
-int	systrace_attach(struct fsystrace *, pid_t);
-int	systrace_detach(struct str_process *);
+int	systrace_attach(struct inst *, struct fsystrace *, pid_t);
+int	systrace_detach(struct inst *, struct str_process *);
 int	systrace_answer(struct str_process *, struct systrace_answer *);
 int     systrace_setscriptname(struct str_process *,
 	    struct systrace_scriptname *);
 int     systrace_prepinject(struct str_process *, struct systrace_inject *);
 int     systrace_inject(struct str_process *, int);
 int	systrace_io(struct str_process *, struct systrace_io *);
-int	systrace_policy(struct fsystrace *, struct systrace_policy *);
+int	systrace_policy(struct inst *, struct fsystrace *, struct systrace_policy *);
 int	systrace_preprepl(struct str_process *, struct systrace_replace *);
 int	systrace_replace(struct str_process *, size_t, register_t []);
 int	systrace_getcwd(struct fsystrace *, struct str_process *);
@@ -165,8 +165,8 @@
 void	systrace_replacefree(struct str_process *);
 
 int	systrace_processready(struct str_process *);
-struct proc *systrace_find(struct str_process *);
-struct str_process *systrace_findpid(struct fsystrace *fst, pid_t pid);
+struct proc *systrace_find(struct inst *, struct str_process *);
+struct str_process *systrace_findpid(struct inst *, struct fsystrace *fst, pid_t pid);
 void	systrace_wakeup(struct fsystrace *);
 void	systrace_closepolicy(struct fsystrace *, struct str_policy *);
 int	systrace_insert_process(struct fsystrace *, struct proc *);
@@ -335,7 +335,7 @@
 	rw_enter_write(&fst->lock);
 	systrace_unlock();
 	if (pid) {
-		strp = systrace_findpid(fst, pid);
+		strp = systrace_findpid(p->p_inst, fst, pid);
 		if (strp == NULL) {
 			ret = ESRCH;
 			goto unlock;
@@ -348,11 +348,11 @@
 		if (!pid)
 			ret = EINVAL;
 		else
-			ret = systrace_attach(fst, pid);
+			ret = systrace_attach(p->p_inst, fst, pid);
 		DPRINTF(("%s: attach to %u: %d\n", __func__, pid, ret));
 		break;
 	case STRIOCDETACH:
-		ret = systrace_detach(strp);
+		ret = systrace_detach(p->p_inst, strp);
 		break;
 	case STRIOCREPORT:
 		SET(strp->flags, STR_PROC_REPORT);
@@ -371,7 +371,7 @@
 		ret = systrace_prepinject(strp, (struct systrace_inject *)data);
 		break;
 	case STRIOCPOLICY:
-		ret = systrace_policy(fst, (struct systrace_policy *)data);
+		ret = systrace_policy(p->p_inst, fst, (struct systrace_policy *)data);
 		break;
 	case STRIOCREPLACE:
 		ret = systrace_preprepl(strp, (struct systrace_replace *)data);
@@ -471,7 +471,7 @@
 	    strp = TAILQ_FIRST(&fst->processes)) {
 		struct proc *q = strp->proc;
 
-		systrace_detach(strp);
+		systrace_detach(p->p_inst, strp);
 		psignal(q, SIGKILL);
 	}
 
@@ -610,11 +610,11 @@
 }
 
 struct proc *
-systrace_find(struct str_process *strp)
+systrace_find(struct inst *inst, struct str_process *strp)
 {
 	struct proc *proc;
 
-	if ((proc = pfind(strp->pid)) == NULL)
+	if ((proc = pfind(inst->inst_proc, strp->pid)) == NULL)
 		return (NULL);
 
 	if (proc != strp->proc)
@@ -642,7 +642,7 @@
 		/* Insert Exit message */
 		systrace_msg_child(fst, strp, -1);
 
-		systrace_detach(strp);
+		systrace_detach(proc->p_inst, strp);
 		rw_exit_write(&fst->lock);
 	} else
 		systrace_unlock();
@@ -668,7 +668,7 @@
 
 	if (systrace_insert_process(fst, p))
 		goto out;
-	if ((strp = systrace_findpid(fst, p->p_pid)) == NULL)
+	if ((strp = systrace_findpid(p->p_inst, fst, p->p_pid)) == NULL)
 		panic("systrace_fork");
 
 	/* Reference policy */
@@ -1058,7 +1058,7 @@
 }
 
 int
-systrace_policy(struct fsystrace *fst, struct systrace_policy *pol)
+systrace_policy(struct inst *inst, struct fsystrace *fst, struct systrace_policy *pol)
 {
 	struct str_policy *strpol;
 	struct str_process *strp;
@@ -1085,7 +1085,7 @@
 		if (strpol == NULL)
 			return (EINVAL);
 
-		strp = systrace_findpid(fst, pol->strp_pid);
+		strp = systrace_findpid(inst, fst, pol->strp_pid);
 		if (strp == NULL)
 			return (EINVAL);
 
@@ -1216,12 +1216,12 @@
 }
 
 int
-systrace_attach(struct fsystrace *fst, pid_t pid)
+systrace_attach(struct inst *inst, struct fsystrace *fst, pid_t pid)
 {
 	int error = 0;
 	struct proc *proc, *p = curproc;
 
-	if ((proc = pfind(pid)) == NULL) {
+	if ((proc = pfind(inst->inst_proc, pid)) == NULL) {
 		error = ESRCH;
 		goto out;
 	}
@@ -1550,7 +1550,7 @@
 }
 
 struct str_process *
-systrace_findpid(struct fsystrace *fst, pid_t pid)
+systrace_findpid(struct inst *inst, struct fsystrace *fst, pid_t pid)
 {
 	struct str_process *strp;
 	struct proc *proc = NULL;
@@ -1562,13 +1562,13 @@
 	if (strp == NULL)
 		return (NULL);
 
-	proc = systrace_find(strp);
+	proc = systrace_find(inst, strp);
 
 	return (proc ? strp : NULL);
 }
 
 int
-systrace_detach(struct str_process *strp)
+systrace_detach(struct inst *inst, struct str_process *strp)
 {
 	struct proc *proc;
 	struct fsystrace *fst = NULL;
@@ -1576,7 +1576,7 @@
 
 	DPRINTF(("%s: Trying to detach from %d\n", __func__, strp->pid));
 
-	if ((proc = systrace_find(strp)) != NULL) {
+	if ((proc = systrace_find(inst, strp)) != NULL) {
 		atomic_clearbits_int(&proc->p_flag, P_SYSTRACE);
 		proc->p_systrace = NULL;
 	} else
Index: sys/dev/wscons/wsdisplay_compat_usl.c
===================================================================
RCS file: /cvs/OpenBSD/src/sys/dev/wscons/wsdisplay_compat_usl.c,v
retrieving revision 1.19
retrieving revision 1.19.10.1
diff -u -r1.19 -r1.19.10.1
--- sys/dev/wscons/wsdisplay_compat_usl.c	14 Feb 2007 01:12:16 -0000	1.19
+++ sys/dev/wscons/wsdisplay_compat_usl.c	16 Sep 2008 23:10:38 -0000	1.19.10.1
@@ -145,7 +145,7 @@
 usl_sync_check(sd)
 	struct usl_syncdata *sd;
 {
-	if (sd->s_proc == pfind(sd->s_pid))
+	if (sd->s_proc == pfind(sd->s_proc->p_inst->inst_proc, sd->s_pid))
 		return (1);
 	DPRINTF(("usl_sync_check: process %d died\n", sd->s_pid));
 	usl_sync_done(sd);
Index: sys/kern/init_main.c
===================================================================
RCS file: /cvs/OpenBSD/src/sys/kern/init_main.c,v
retrieving revision 1.150
retrieving revision 1.150.4.10
diff -u -r1.150 -r1.150.4.10
--- sys/kern/init_main.c	9 Jun 2008 07:07:16 -0000	1.150
+++ sys/kern/init_main.c	18 Feb 2009 18:20:20 -0000	1.150.4.10
@@ -217,6 +217,8 @@
 	tty_init();		/* initialise tty's */
 	cpu_startup();
 
+	printf("cpu is started\n");
+
 	/*
 	 * Initialize mbuf's.  Do this now because we might attempt to
 	 * allocate mbufs or mbuf clusters during autoconfiguration.
@@ -227,6 +229,11 @@
 	soinit();
 
 	/*
+	 * Initialise instance structures.
+	 */
+	instinit();
+
+	/*
 	 * Initialize process and pgrp structures.
 	 */
 	procinit();
@@ -252,16 +259,12 @@
 	/*
 	 * Create process 0 (the swapper).
 	 */
-
 	process0.ps_mainproc = p;
 	TAILQ_INIT(&process0.ps_threads);
 	TAILQ_INSERT_TAIL(&process0.ps_threads, p, p_thr_link);
 	p->p_p = &process0;
 
-	LIST_INSERT_HEAD(&allproc, p, p_list);
 	p->p_pgrp = &pgrp0;
-	LIST_INSERT_HEAD(PIDHASH(0), p, p_hash);
-	LIST_INSERT_HEAD(PGRPHASH(0), &pgrp0, pg_hash);
 	LIST_INIT(&pgrp0.pg_members);
 	LIST_INSERT_HEAD(&pgrp0.pg_members, p, p_pglist);
 
@@ -282,9 +285,23 @@
 	/* Create credentials. */
 	cred0.p_refcnt = 1;
 	p->p_cred = &cred0;
-	p->p_ucred = crget();
+	p->p_ucred = crnew();
 	p->p_ucred->cr_ngroups = 1;	/* group 0 */
 
+	/* 
+	 * FIXME: eventually instances should all be "flat", but for now
+	 * the "main" instance, with id 0,  gets special handling (can't
+	 * be killed).
+	 */
+
+	if (NULL == (p->p_ucred->cr_inst = instknew(0)))
+		panic("couldn't allocate kernel instance");
+
+	p->p_ucred->cr_inst->inst_proc = proc_instinit(p->p_inst);
+
+	pgrp_instadd(p->p_inst->inst_proc, p->p_pgrp);
+	proc_instadd(p->p_inst->inst_proc, p);
+
 	/* Initialize signal state for process 0. */
 	signal_init();
 	p->p_sigacts = &sigacts0;
@@ -422,6 +439,9 @@
 	    &initproc))
 		panic("fork init");
 
+	/* Set "init" process. */
+	p->p_inst->inst_proc->initproc = initproc;
+
 	/*
 	 * Create any kernel threads whose creation was deferred because
 	 * initproc had not yet been created.
@@ -478,7 +498,7 @@
 #else
 	boottime = mono_time = time;	
 #endif
-	LIST_FOREACH(p, &allproc, p_list) {
+	PROCLIST_FOREACH(p, initproc, p_list) {
 		p->p_stats->p_start = boottime;
 		microuptime(&p->p_cpu->ci_schedstate.spc_runtime);
 		p->p_rtime.tv_sec = p->p_rtime.tv_usec = 0;
Index: sys/kern/kern_descrip.c
===================================================================
RCS file: /cvs/OpenBSD/src/sys/kern/kern_descrip.c,v
retrieving revision 1.79
retrieving revision 1.79.4.3
diff -u -r1.79 -r1.79.4.3
--- sys/kern/kern_descrip.c	12 Jun 2008 18:10:06 -0000	1.79
+++ sys/kern/kern_descrip.c	27 Sep 2008 14:09:44 -0000	1.79.4.3
@@ -383,13 +383,14 @@
 
 			so->so_pgid = (long)SCARG(uap, arg);
 			so->so_siguid = p->p_cred->p_ruid;
+			so->so_siginstid = p->p_inst->inst_id;
 			so->so_sigeuid = p->p_ucred->cr_uid;
 			break;
 		}
 		if ((long)SCARG(uap, arg) <= 0) {
 			SCARG(uap, arg) = (void *)(-(long)SCARG(uap, arg));
 		} else {
-			struct proc *p1 = pfind((long)SCARG(uap, arg));
+			struct proc *p1 = pfind(p->p_inst->inst_proc, (long)SCARG(uap, arg));
 			if (p1 == 0) {
 				error = ESRCH;
 				break;
@@ -838,7 +839,7 @@
 	extern int cmask;
 
 	newfdp = pool_get(&fdesc_pool, PR_WAITOK|PR_ZERO);
-	if (p != NULL) {
+	if (p) {
 		struct filedesc *fdp = p->p_fd;
 
 		newfdp->fd_fd.fd_cdir = fdp->fd_cdir;
Index: sys/kern/kern_event.c
===================================================================
RCS file: /cvs/OpenBSD/src/sys/kern/kern_event.c,v
retrieving revision 1.33
retrieving revision 1.33.4.2
diff -u -r1.33 -r1.33.4.2
--- sys/kern/kern_event.c	6 May 2008 20:57:19 -0000	1.33
+++ sys/kern/kern_event.c	18 Sep 2008 21:04:55 -0000	1.33.4.2
@@ -193,7 +193,7 @@
 {
 	struct proc *p;
 
-	p = pfind(kn->kn_id);
+	p = pfind(curproc->p_inst->inst_proc, kn->kn_id);
 	if (p == NULL)
 		return (ESRCH);
 
Index: sys/kern/kern_exit.c
===================================================================
RCS file: /cvs/OpenBSD/src/sys/kern/kern_exit.c,v
retrieving revision 1.73
retrieving revision 1.73.4.9
diff -u -r1.73 -r1.73.4.9
--- sys/kern/kern_exit.c	11 May 2008 23:54:40 -0000	1.73
+++ sys/kern/kern_exit.c	18 Feb 2009 12:43:25 -0000	1.73.4.9
@@ -77,6 +77,9 @@
 
 #include <uvm/uvm_extern.h>
 
+
+void		waitinst(struct proc *);
+
 /*
  * exit --
  *	Death of process.
@@ -105,6 +108,35 @@
 }
 #endif
 
+void
+waitinst(struct proc *p)
+{
+	struct proc *q, *nq;
+
+	while ( ! LIST_EMPTY(&p->p_children)) {
+		for (q = LIST_FIRST(&p->p_children); q; q = nq) {
+			nq = LIST_NEXT(q, p_sibling);
+			if (SZOMB != q->p_stat)
+				continue;
+
+			log(LOG_NOTICE, "instance-%u: zapping %d\n", 
+					p->p_inst->inst_id, q->p_pid);
+
+			scheduler_wait_hook(p, q);
+			q->p_xstat = 0;
+			ruadd(&p->p_stats->p_cru, q->p_ru);
+			proc_zap(q);
+		}
+		log(LOG_NOTICE, "instance-%u: sleeping\n",
+				p->p_inst->inst_id);
+		if (LIST_EMPTY(&p->p_children))
+			break;
+		tsleep(p, PUSER, "instwait", 0);
+	}
+	log(LOG_NOTICE, "instance-%u: done waiting\n",
+			p->p_inst->inst_id);
+}
+
 /*
  * Exit: deallocate address space and other resources, change proc state
  * to zombie, and unlink proc from allproc and parent's lists.  Save exit
@@ -115,10 +147,18 @@
 {
 	struct proc *q, *nq;
 
-	if (p->p_pid == 1)
+	if (p->p_pid == 1 && p->p_inst->inst_id == 0)
 		panic("init died (signal %d, exit %d)",
 		    WTERMSIG(rv), WEXITSTATUS(rv));
-	
+
+	/* If the instance's init has died, kill off children. */
+
+	if (p == p->p_inst->inst_proc->initproc) {
+		q = LIST_FIRST(&p->p_children);
+		for (; q; q = LIST_NEXT(q, p_sibling))
+			psignal(q, SIGKILL);
+	}
+
 	/* unlink ourselves from the active threads */
 	TAILQ_REMOVE(&p->p_p->ps_threads, p, p_thr_link);
 #ifdef RTHREADS
@@ -167,6 +207,7 @@
 	atomic_clearbits_int(&p->p_flag, P_TRACED);
 	if (p->p_flag & P_PPWAIT) {
 		atomic_clearbits_int(&p->p_flag, P_PPWAIT);
+		KASSERT(p->p_pptr);
 		wakeup(p->p_pptr);
 	}
 	p->p_sigignore = ~0;
@@ -232,6 +273,10 @@
 	if (ISSET(p->p_flag, P_SYSTRACE))
 		systrace_exit(p);
 #endif
+
+	if (p == p->p_inst->inst_proc->initproc)
+		waitinst(p);
+
 	/*
 	 * NOTE: WE ARE NO LONGER ALLOWED TO SLEEP!
 	 */
@@ -246,17 +291,17 @@
          */
 	LIST_REMOVE(p, p_hash);
 	LIST_REMOVE(p, p_list);
-	LIST_INSERT_HEAD(&zombproc, p, p_list);
+	LIST_INSERT_HEAD(&p->p_inst->inst_proc->zombproc, p, p_list);
 
 	/*
 	 * Give orphaned children to init(8).
 	 */
 	q = LIST_FIRST(&p->p_children);
 	if (q)		/* only need this if any child is S_ZOMB */
-		wakeup(initproc);
+		wakeup(p->p_inst->inst_proc->initproc);
 	for (; q != 0; q = nq) {
 		nq = LIST_NEXT(q, p_sibling);
-		proc_reparent(q, initproc);
+		proc_reparent(q, p->p_inst->inst_proc->initproc);
 		/*
 		 * Traced processes are killed
 		 * since their existence means someone is screwing up.
@@ -293,9 +338,10 @@
 	 * the P_NOCLDWAIT flag set, notify process 1 instead (and hope it
 	 * will handle this situation).
 	 */
-	if ((p->p_flag & P_NOZOMBIE) || (p->p_pptr->p_flag & P_NOCLDWAIT)) {
+	if (p->p_pptr && ((p->p_flag & P_NOZOMBIE) || 
+				(p->p_pptr->p_flag & P_NOCLDWAIT))) {
 		struct proc *pp = p->p_pptr;
-		proc_reparent(p, initproc);
+		proc_reparent(p, p->p_inst->inst_proc->initproc);
 		/*
 		 * If this was the last child of our parent, notify
 		 * parent, so in case he was wait(2)ing, he will
@@ -305,9 +351,13 @@
 			wakeup(pp);
 	}
 
-	if (p->p_exitsig != 0)
+	if (p->p_exitsig != 0) {
+		KASSERT(p->p_pptr);
 		psignal(p->p_pptr, P_EXITSIG(p));
-	wakeup(p->p_pptr);
+	}
+
+	if (p->p_pptr)
+		wakeup(p->p_pptr);
 
 	/*
 	 * Release the process's signal state.
@@ -400,7 +450,7 @@
 		LIST_REMOVE(p, p_hash);
 		mtx_leave(&deadproc_mutex);
 		KERNEL_PROC_LOCK(curproc);
-
+		
 		/*
 		 * Give machine-dependent code a chance to free any
 		 * resources it couldn't free while still running on
@@ -417,7 +467,7 @@
 		uvm_exit(p);
 
 		/* Process is now a true zombie. */
-		if ((p->p_flag & P_NOZOMBIE) == 0) {
+		if (p->p_pptr && (p->p_flag & P_NOZOMBIE) == 0) {
 			p->p_stat = SZOMB;
 
 			/* Wake up the parent so it can get exit status. */
@@ -488,7 +538,7 @@
 			 * If we got the child via a ptrace 'attach',
 			 * we need to give it back to the old parent.
 			 */
-			if (p->p_oppid && (t = pfind(p->p_oppid))) {
+			if (p->p_oppid && (t = pfind(p->p_inst->inst_proc, p->p_oppid))) {
 				p->p_oppid = 0;
 				proc_reparent(p, t);
 				if (p->p_exitsig != 0)
@@ -552,7 +602,7 @@
 	if (child->p_pptr == parent)
 		return;
 
-	if (parent == initproc)
+	if (parent == parent->p_inst->inst_proc->initproc)
 		child->p_exitsig = SIGCHLD;
 
 	LIST_REMOVE(child, p_sibling);
@@ -572,8 +622,11 @@
 	 * Unlink it from its process group and free it.
 	 */
 	leavepgrp(p);
-	LIST_REMOVE(p, p_list);	/* off zombproc */
-	LIST_REMOVE(p, p_sibling);
+
+	if (p->p_pptr)
+		LIST_REMOVE(p, p_sibling);
+
+	LIST_REMOVE(p, p_list);
 
 	/*
 	 * Decrement the count of procs running with this uid.
Index: sys/kern/kern_fork.c
===================================================================
RCS file: /cvs/OpenBSD/src/sys/kern/kern_fork.c,v
retrieving revision 1.95
retrieving revision 1.95.4.14
diff -u -r1.95 -r1.95.4.14
--- sys/kern/kern_fork.c	11 May 2008 23:54:40 -0000	1.95
+++ sys/kern/kern_fork.c	18 Feb 2009 18:20:20 -0000	1.95.4.14
@@ -70,10 +70,22 @@
 pid_t	lastpid;
 struct	forkstat forkstat;
 
-void fork_return(void *);
-int pidtaken(pid_t);
+void 	fork_return(void *);
+int 	pidtaken(struct inst_proc *, pid_t);
+void 	process_new(struct proc *);
+pid_t	pid_new(struct inst *);
 
-void process_new(struct proc *, struct proc *);
+
+pid_t
+pid_new(struct inst *inst)
+{
+
+	/* Find an unused pid satisfying 1 <= lastpid <= PID_MAX */
+	do {
+		lastpid = 1 + (randompid ? arc4random() : lastpid) % PID_MAX;
+	} while (pidtaken(inst->inst_proc, lastpid));
+	return(lastpid);
+}
 
 void
 fork_return(void *arg)
@@ -107,6 +119,7 @@
 	    NULL, retval, NULL));
 }
 
+
 int
 sys_rfork(struct proc *p, void *v, register_t *retval)
 {
@@ -153,7 +166,7 @@
  * Allocate and initialize a new process.
  */
 void
-process_new(struct proc *newproc, struct proc *parent)
+process_new(struct proc *newproc)
 {
 	struct process *pr;
 
@@ -167,6 +180,131 @@
 /* print the 'table full' message once per 10 seconds */
 struct timeval fork_tfmrate = { 10, 0 };
 
+
+int
+forkinst1(struct proc *p1, instid_t id, register_t *retval)
+{
+	struct proc	*p2;
+	struct vmspace	*vm;
+	vaddr_t		 uaddr;
+	int		 s;
+	struct inst	*inst;
+
+	extern void endtsleep(void *);
+	extern void realitexpire(void *);
+
+	if (0 != p1->p_cred->p_ruid)
+		return(EPERM);
+
+	if (NULL == (inst = instpnew(p1, id)))
+		return(EINSTEXIST);
+
+	(void)chgproccnt(0, 1);
+
+	uaddr = uvm_km_alloc1(kernel_map, USPACE, USPACE_ALIGN, 1);
+	if (uaddr == 0) {
+		(void)chgproccnt(0, -1);
+		instfree(inst);
+		return(ENOMEM);
+	}
+
+	/*
+	 * From now on, we're committed to the fork and cannot fail.
+	 */
+
+	inst->inst_proc = proc_instinit(inst);
+
+	p2 = pool_get(&proc_pool, PR_WAITOK);
+
+	p2->p_stat = SIDL;
+	p2->p_exitsig = 0;
+	p2->p_flag = 0;
+
+	process_new(p2);
+
+	bzero(&p2->p_startzero,
+	    (unsigned) ((caddr_t)&p2->p_endzero - (caddr_t)&p2->p_startzero));
+	bcopy(&p1->p_startcopy, &p2->p_startcopy,
+	    (unsigned) ((caddr_t)&p2->p_endcopy - (caddr_t)&p2->p_startcopy));
+
+	timeout_set(&p2->p_sleep_to, endtsleep, p2);
+	timeout_set(&p2->p_realit_to, realitexpire, p2);
+
+	p2->p_cpu = p1->p_cpu;
+	p2->p_emul = p1->p_emul;
+	bcopy("init", p2->p_comm, sizeof("init"));
+
+	atomic_setbits_int(&p2->p_flag, p1->p_flag & (P_SUGID | P_SUGIDEXEC));
+
+	p2->p_p->ps_cred = pool_get(&pcred_pool, PR_WAITOK | PR_ZERO);
+	bcopy(p1->p_p->ps_cred, p2->p_p->ps_cred, sizeof(*p2->p_p->ps_cred));
+	p2->p_p->ps_cred->p_refcnt = 1;
+	p2->p_p->ps_cred->pc_ucred = crnew();
+	p2->p_p->ps_cred->pc_ucred->cr_inst = inst;
+
+	p2->p_textvp = p1->p_textvp;
+	if (p2->p_textvp)
+		VREF(p2->p_textvp);
+
+	p2->p_fd = fdinit(p1);
+
+	p2->p_p->ps_limit = limcopy(p1->p_p->ps_limit);
+
+	p2->p_pptr = NULL;
+
+	LIST_INIT(&p2->p_children);
+
+	bzero(&p2->p_sibling, sizeof(p2->p_sibling));
+
+	scheduler_fork_hook(p1, p2);
+
+	p2->p_sigacts = sigactsinit(p1);
+
+	if (p2->p_emul->e_proc_fork)
+		(*p2->p_emul->e_proc_fork)(p2, p1);
+
+	p2->p_addr = (struct user *)uaddr;
+
+	uvm_fork(p1, p2, FALSE, NULL, 0, child_return, p2);
+
+	timeout_set(&p2->p_stats->p_virt_to, virttimer_trampoline, p2);
+	timeout_set(&p2->p_stats->p_prof_to, proftimer_trampoline, p2);
+
+	vm = p2->p_vmspace;
+
+	forkstat.cntfork++;
+	forkstat.sizfork += vm->vm_dsize + vm->vm_ssize;
+
+#ifdef GLOBAL_HASH
+	p2->p_pid = pid_new(p2->p_inst);
+#else
+	p2->p_pid = 1;
+#endif
+
+	proc_instadd(p2->p_inst->inst_proc, p2);
+	bzero(&p2->p_pglist, sizeof(p2->p_pglist));
+	LIST_INSERT_AFTER(p1, p2, p_pglist);
+	pgrpinit(p1, p2);
+
+	SCHED_LOCK(s);
+ 	getmicrotime(&p2->p_stats->p_start);
+	p2->p_acflag = AFORK;
+	p2->p_stat = SRUN;
+	setrunqueue(p2);
+	SCHED_UNLOCK(s);
+
+	uvmexp.forks++;
+
+	/* Set "init" process. */
+	p2->p_inst->inst_proc->initproc = p2;
+
+	retval[0] = p2->p_inst->inst_id;
+	retval[1] = 0;
+
+	return (0);
+}
+
+
 int
 fork1(struct proc *p1, int exitsig, int flags, void *stack, size_t stacksize,
     void (*func)(void *), void *arg, register_t *retval,
@@ -178,6 +316,7 @@
 	int count;
 	vaddr_t uaddr;
 	int s;
+
 	extern void endtsleep(void *);
 	extern void realitexpire(void *);
 
@@ -232,10 +371,10 @@
 		p2->p_p = p1->p_p;
 		TAILQ_INSERT_TAIL(&p2->p_p->ps_threads, p2, p_thr_link);
 	} else {
-		process_new(p2, p1);
+		process_new(p2);
 	}
 #else
-	process_new(p2, p1);
+	process_new(p2);
 #endif
 
 	/*
@@ -381,14 +520,10 @@
 		forkstat.sizkthread += vm->vm_dsize + vm->vm_ssize;
 	}
 
-	/* Find an unused pid satisfying 1 <= lastpid <= PID_MAX */
-	do {
-		lastpid = 1 + (randompid ? arc4random() : lastpid) % PID_MAX;
-	} while (pidtaken(lastpid));
-	p2->p_pid = lastpid;
+	p2->p_pid = pid_new(p2->p_inst);
+
+	proc_instadd(p2->p_inst->inst_proc, p2);
 
-	LIST_INSERT_HEAD(&allproc, p2, p_list);
-	LIST_INSERT_HEAD(PIDHASH(p2->p_pid), p2, p_hash);
 	LIST_INSERT_HEAD(&p1->p_children, p2, p_sibling);
 	LIST_INSERT_AFTER(p1, p2, p_pglist);
 	if (p2->p_flag & P_TRACED) {
@@ -474,15 +609,15 @@
  * Checks for current use of a pid, either as a pid or pgid.
  */
 int
-pidtaken(pid_t pid)
+pidtaken(struct inst_proc *ip, pid_t pid)
 {
 	struct proc *p;
 
-	if (pfind(pid) != NULL)
+	if (pfind(ip, pid) != NULL)
 		return (1);
-	if (pgfind(pid) != NULL)
+	if (pgfind(ip, pid) != NULL)
 		return (1);
-	LIST_FOREACH(p, &zombproc, p_list)
+	LIST_FOREACH(p, &ip->zombproc, p_list)
 		if (p->p_pid == pid || p->p_pgid == pid)
 			return (1);
 	return (0);
Index: sys/kern/kern_inst.c
===================================================================
RCS file: sys/kern/kern_inst.c
diff -N sys/kern/kern_inst.c
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ sys/kern/kern_inst.c	18 Feb 2009 18:20:20 -0000	1.1.2.12
@@ -0,0 +1,364 @@
+/*
+ * Copyright (c) 2008 Kristaps Dzonsons <kristaps@mult.bsd.lv>
+ *
+ * Permission to use, copy, modify, and distribute this software for any
+ * purpose with or without fee is hereby granted, provided that the
+ * above copyright notice and this permission notice appear in all
+ * copies.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL
+ * WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED
+ * WARRANTIES OF MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE
+ * AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL
+ * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR
+ * PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
+ * TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
+ * PERFORMANCE OF THIS SOFTWARE.
+ */
+#include <sys/param.h>
+#include <sys/malloc.h>
+#include <sys/inst.h>
+#include <sys/mount.h>
+#include <sys/pool.h>
+#include <sys/signalvar.h>
+#include <sys/sysctl.h>
+#include <sys/systm.h>
+#include <sys/syscallargs.h>
+
+#include <dev/rndvar.h>
+
+#define	INST_HASH(id)	(&inst_htab[(id) & inst_hmask])
+#define	INST_SLOP	(2 * sizeof(struct kinfo_inst))
+
+LIST_HEAD(inst_head, inst);
+
+struct instlist		 inst_all;
+
+struct pool	 	 inst_pool;
+u_long		 	 inst_hmask;
+u_int		 	 inst_count;
+struct inst_head	*inst_htab;
+
+inline int		 instexist(instid_t);
+struct inst 		*instnew(instid_t);
+inline struct inst 	*instfind(instid_t);
+
+int		 	 killinst1(struct inst *, int);
+void		 	 fill_inst(struct inst *, struct kinfo_inst *);
+
+
+void
+instinit(void)
+{
+
+	pool_init(&inst_pool, sizeof(struct inst), 0, 0, 0, 
+			"instpl", &pool_allocator_nointr);
+
+	inst_count = 0;
+	inst_hmask = 0;
+
+	inst_htab = hashinit(16, M_INST, M_NOWAIT, &inst_hmask);
+
+	if (NULL == inst_htab) 
+		panic("instinit: hashinit");
+
+	LIST_INIT(&inst_all);
+}
+
+
+inline int
+instexist(instid_t id)
+{
+	struct inst	*ip;
+
+	LIST_FOREACH(ip, INST_HASH(id), inst_hash)
+		if (ip->inst_id == id)
+			return(1);
+	return(0);
+}
+
+
+inline struct inst *
+instfind(instid_t id)
+{
+	struct inst	*ip;
+
+	LIST_FOREACH(ip, INST_HASH(id), inst_hash)
+		if (ip->inst_id == id)
+			break;
+
+	return(ip);
+}
+
+
+struct inst *
+instkfind(instid_t id)
+{
+
+	/* 
+	 * Find instance without an instance context.  This is allowed
+	 * without needing to check for permission. 
+	 */
+	return(instfind(id));
+}
+
+
+struct inst *
+instpfind(struct proc *cp, instid_t id, enum instop op)
+{
+
+	/* 
+	 * TODO: check for access from one instance to the next.  For
+	 * now, accept all requests from the superuser.
+	 */
+
+	if (suser(cp, 0))
+		return(NULL);
+	return(instfind(id));
+}
+
+
+struct inst *
+instnew(instid_t id)
+{
+	struct inst	*inst;
+
+	if (INST_NOID != id && instexist(id))
+		return(NULL);
+
+	inst = pool_get(&inst_pool, PR_WAITOK|PR_ZERO);
+
+	inst->inst_ref = 1;
+
+	if (INST_NOID == id) {
+		do 
+			inst->inst_id = 1 + arc4random() % INST_MAX;
+		while (instexist(inst->inst_id));
+	}  else
+		inst->inst_id = id;
+	
+	LIST_INSERT_HEAD(INST_HASH(inst->inst_id), inst, inst_hash);
+	LIST_INSERT_HEAD(&inst_all, inst, inst_list);
+	inst_count++;
+
+	return(inst);
+}
+
+
+struct inst *
+instpnew(struct proc *cp, instid_t id)
+{
+
+	/* 
+	 * TODO: check for access to start a new instance.  For now,
+	 * accept all requests from the superuser.
+	 */
+	if (suser(cp, 0))
+		return(NULL);
+	return(instnew(id));
+}
+
+
+struct inst *
+instknew(instid_t id)
+{
+
+	/* 
+	 * New instance without an instance context.  This is allowed
+	 * without needing to check for permission. 
+	 */
+	return(instnew(id));
+}
+
+
+void
+instfree(struct inst *inst)
+{
+	instid_t	 id;
+
+	KASSERT(inst);
+
+	if (--inst->inst_ref != 0)
+		return;
+
+	if (inst->inst_proc)
+		proc_instfree(inst->inst_proc);
+
+	id = inst->inst_id;
+
+	LIST_REMOVE(inst, inst_hash);
+	LIST_REMOVE(inst, inst_list);
+	inst_count--;
+
+	pool_put(&inst_pool, inst);
+}
+
+
+void
+fill_inst(struct inst *p, struct kinfo_inst *ki)
+{
+
+	bzero(ki, sizeof(*ki));
+	ki->inst_id = p->inst_id;
+	ki->inst_ref = p->inst_ref;
+}
+
+
+int
+sysctl_doinst(struct proc *cp, int *name, 
+		u_int namelen, char *where, size_t *sizep)
+{
+	struct inst	*p;
+	char 		*dp;
+	int 		 arg, buflen, elem_size, elem_count, error, 
+			 needed, type, op;
+	struct kinfo_inst *kinst;
+
+	dp = where;
+	buflen = where != NULL ? *sizep : 0;
+	needed = error = 0;
+	type = name[0];
+
+	if (namelen != 5 || name[3] < 0 || name[4] < 0)
+		return (EINVAL);
+
+	op = name[1];
+	arg = name[2];
+	elem_size = name[3];
+	elem_count = name[4];
+	kinst = malloc(sizeof(struct kinfo_inst), M_TEMP, M_WAITOK);
+
+	p = LIST_FIRST(&inst_all);
+
+	for ( ; p; p = LIST_NEXT(p, inst_list)) {
+		switch (op) {
+		case KERN_INST_ALL:
+			break;
+		case KERN_INST_INSTID:
+			if (p->inst_id != (instid_t)arg)
+				continue;
+			break;
+		default:
+			error = EINVAL;
+			goto err;
+		}
+
+		/* For access-control rules... */
+		if (NULL == (p = instpfind(cp, p->inst_id, INST_KPROC)))
+			continue;
+
+		if (buflen >= elem_size && elem_count > 0) {
+			fill_inst(p, kinst);
+			/*
+			 * Copy out elem_size, but not larger than the
+			 * size of a struct kinfo_inst.
+			 */
+			error = copyout(kinst, dp, min(sizeof(*kinst), 
+						elem_size));
+			if (error)
+				goto err;
+
+			dp += elem_size;
+			buflen -= elem_size;
+			elem_count--;
+		}
+		needed += elem_size;
+	}
+
+	if (where != NULL) {
+		*sizep = dp - where;
+		if (needed > *sizep) {
+			error = ENOMEM;
+			goto err;
+		}
+	} else {
+		needed += INST_SLOP;
+		*sizep = needed;
+	}
+
+err:
+	if (kinst)
+		free(kinst, M_TEMP);
+
+	return (error);
+}
+
+
+int
+sys_killinst(struct proc *cp, void *v, register_t *retval)
+{
+	struct sys_killinst_args /* {
+		syscallarg(instid_t) id;
+		syscallarg(int) signum;
+	} */ *uap = v;
+	struct inst	*inst;
+	struct proc	*p;
+	instid_t	 id;
+	int		 signum, nsigs;
+
+	signum = SCARG(uap, signum);
+
+	switch (signum) {
+	case (SIGINST_TERM):
+		/* FALLTHROUGH */
+	case (SIGINST_KILL):
+		break;
+	default:
+		return(EINVAL);
+	}
+
+	id = SCARG(uap, id);
+
+	if (INST_NOID == id) {
+		nsigs = 0;
+		inst = LIST_FIRST(&inst_all);
+
+		for ( ; inst; inst = LIST_NEXT(inst, inst_list)) {
+			/* For access rules. */
+			inst = instpfind(cp, inst->inst_id, INST_SIG);
+			if (NULL == inst) 
+				continue;
+			if (inst->inst_id == cp->p_inst->inst_id)
+				continue;
+			if (inst->inst_id == 0) /* FIXME */
+				continue;
+
+			nsigs++;
+			p = inst->inst_proc->initproc;
+			psignal(p, signum);
+		}
+		return(0 == nsigs ? EINSTSRCH : 0);
+	}
+
+	if (id == 0) /* FIXME */
+		return(EINSTSRCH);
+
+	inst = instpfind(cp, id, INST_SIG);
+	if (NULL == inst) 
+		return(EINSTSRCH);
+
+	p = inst->inst_proc->initproc;
+	psignal(p, signum);
+	return(0);
+}
+
+
+int
+sys_getinstid(struct proc *p, void *v, register_t *retval)
+{
+
+	*retval = p->p_inst->inst_id;
+	return(0);
+}
+
+
+int
+sys_forkinst(struct proc *p, void *v, register_t *retval)
+{
+	struct sys_forkinst_args /* {
+		syscallarg(instid_t) id;
+	} */ *uap = v;
+
+	return(forkinst1(p, SCARG(uap, id), retval));
+}
+
